#ifndef FILEREADER_H
#define FILEREADER_H

class FileReader
{
public:
        FileReader(const char * filename, long bufferSize = 65535L);
        FileReader(int handle, long bufferSize = 65535L);

        ~FileReader();

        bool checkStatus() const;

        int getNextByte(unsigned char & ret);

        long getCurrentPosition();

protected:

        void init();

private:
            long    m_bufferIn;
            long    m_bufferOut;
            long    m_curPos;

            unsigned char   *m_buffer;
            long    m_bufferSize;
            int     m_handle;

            bool    m_is_open;
};

#endif

