#ifndef FILEWRITER_H
#define FILEWRITER_H

class FileWriter
{
public:
        FileWriter(const char * filename, long bufferSize = 65535L);
        FileWriter(int handle, long bufferSize = 65535L);

        ~FileWriter();

        bool checkStatus() const;

        int setNextByte(unsigned char data, bool flash = false);

        long getCurrentPosition();

protected:

        void init();

private:
            long    m_bufferIn;
            long    m_curPos;

            unsigned char   *m_buffer;
            long    m_bufferSize;
            int     m_handle;
};

#endif

